<?php
trait EPSession {
    public $sessionData = [];
    public $sessionID = '';
    public function sessionLoad() {
        $path = $this->sessionGetPath();
        if (!file_exists($path)) file_put_contents($path, '{}');
        $this->sessionData = json_decode(file_get_contents($path), true);

    }
    public function sessionSave() {
        $path = $this->sessionGetPath();
        if (file_exists($path)) unlink($path);
        file_put_contents($path, json_encode($this->sessionData));

    }
    public function sessionGetPath() {
        $dir = dirname(__FILE__) . '/../../.wexler/cache';
        if (!file_exists($dir)) mkdir($dir, 0755, true);

        $id = $this->sessionGetID();

        $path = $dir . '/sess_' . $id . '.data';
        return $path;

    }
    public function sessionGetID() {
        if (!empty($this->sessionID)) return $this->sessionID;

        if (!isset($_COOKIE['session'])) {
            $this->sessionID = $this->sessionCreateID();
            setcookie("session", $this->sessionID, time() + 3600, '/');

        } else {
            $this->sessionID = $_COOKIE['session'];
            if (!preg_match('/^([a-zA-Z0-9]+)$/', $this->sessionID)) {
                $this->sessionID = $this->sessionCreateID();
                setcookie("session", $this->sessionID, time() + 3600, '/');

            }
        }

        return $this->sessionID;
    }
    public function sessionCreateID() {
        return $this->RandUnik(32, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789');

    }
    public function sessionGet($name) {
        if (isset($this->sessionData[$name])) return $this->sessionData[$name];
        return false;

    }
    public function sessionSet($name, $value) {
        $this->sessionData[$name] = $value;
        return true;
        
    }
}